<html>
<head><script type="text/javascript">

let square_territory = [];

const DRAW_ONLY_PERIPHERALS_HACK = true;

const PRECISION_SCALE = 1000;

function GenerateChild(name, parent, sibling){
	this.getSiblingsHeight = function(){
		return (this.sibling_ === undefined) ? 0 : (this.sibling_.l + this.sibling_.getSiblingsHeight());
	}

	this.getParentWidth = function(){
		return (this.parent_ === undefined) ? 0 : (this.parent_.l + this.parent_.getParentWidth());
	}

	this.draw = function(){
		drawSquare(this.getParentWidth(), this.getSiblingsHeight(), this.l);
	}
	
	this.draw_offset = function(offset){
		drawSquare(this.getParentWidth() + offset, this.getSiblingsHeight(), this.l);
	}
	
	this.name = name;
	this.parent_ = parent;
	this.sibling_ = sibling;
	if(this.parent_ !== undefined)
		this.parent_.child_ = this;
		
	this.child_ = undefined;
	
	var _d = this.getParentWidth() - this.getSiblingsHeight();
	var _s = this.getParentWidth() + this.getSiblingsHeight();
	
	var delta = 2*PRECISION_SCALE*PRECISION_SCALE - (_d * _d);
	if(delta < 0) //should occour when 2 - (sqrt(2))^2 != 0
		delta = 0;
	
	this.l = (Math.sqrt(delta) - _s) / 2;
	
	square_territory[name] = this.l;

	this.draw();
}

function showSquare_territory(sq_terr){
	var table = document.createElement('table');
	Object.keys(sq_terr).forEach(function(k) {
		var row = table.insertRow();
		var cellkey = row.insertCell();
		var cellval = row.insertCell();
		cellkey.appendChild(document.createTextNode(k));
		cellval.appendChild(document.createTextNode(sq_terr[k]));
	});
	document.getElementById('square_territory').appendChild(table);
}

function CreateGeneration(name, parent, sibling){
	const MAX_CHILDREN = 9;
	const MAX_GENERATION_DEPTH = 4;

	let x = new GenerateChild(name, parent, sibling);
	
	if(name.length >= MAX_GENERATION_DEPTH)
		return x;

	const children_suffix = ['a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i', 'j', 'k', 'l', 'm', 'n', 'o', 'p', 'q', 'r', 's', 't', 'u'];

	var child = sibling;
	for(let i = 0; i < MAX_CHILDREN; i++){
		var child = new CreateGeneration(name + children_suffix[i], x, child);
	}
	
	return x;
}



function CreateA(){
	let ancestor = new CreateGeneration("A", undefined, undefined);
	showSquare_territory(square_territory);
	showPi();
}

function showPi(){
	pi_calc = 8/(PRECISION_SCALE*PRECISION_SCALE)*(Object.keys(square_territory).reduce((tot, k) => tot+square_territory[k]*square_territory[k], 0) - (1*PRECISION_SCALE*PRECISION_SCALE/4));
	
	document.getElementById("pi").innerHTML = pi_calc + "<br>Error: " + (1-pi_calc/Math.PI)*100 + " %";
}

function drawSquare(x, y, len){
	const SCALE = 1000/PRECISION_SCALE;

	var c = document.getElementById("myCanvas");
	var ctx = c.getContext("2d");
	ctx.beginPath();
	ctx.rect(x*SCALE, y*SCALE, len*SCALE, len*SCALE);
	ctx.stroke();
}

</script>
</head>
<body onload="CreateA();">
	<div id="pi"></div>
	<canvas id="myCanvas" width="1000" height="710" style="border:1px solid #e23232;">
		Your browser does not support the HTML5 canvas tag.</canvas>
	</body>
	<div id = "square_territory"></div>


</html>